<template>
  <div class="w100">
    <single-pane
      :capt="dictionaryRu.title"
      class="tnved-page"
    >
      <div class="header">
        <ob-func-panel
          @search="search"
          :columns="[]"
          :show-column-filter="false"
        />
      </div>
      <div
        v-if="!count || count === 0"
        class="not-data"
      >
        {{ dictionaryRu.notData }}
      </div>
      <template v-else>
        <template
          v-if="!preloader"
        >
          <div class="tree">
            <tree-item
              :padding="1"
              @selected="selectData"
              :opening="false"
              v-for="(item, index) in dataSource"
              :item="item"
              :key="index"
              :index-item="index"
              :selectedUuid="selectedData.uuid"
            />
          </div>
          <div class="content-footer">
            <div class="count">
              {{ dictionaryRu.recordsNumber }} {{ count }}
            </div>
            <ob-pagination
              :page="activePage - 1"
              :count="count"
              :page-limit="itemOnPage"
              @on-change="clickPage"
            />
          </div>
        </template>
        <template v-else>
          <Preloader v-if="preloader" />
        </template>
      </template>
    </single-pane>
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-large"
      :is-show-controls="true"
      :is-read-only="true"
      :is-show-pagination="true"
      @toggle-navigation="onToggleNavigation"
    >
      <tnved-item :selected-data="selectedCardInfo"/>
    </ob-modal>
  </div>
</template>

<script>
  import { isEmpty } from '@/helpers';
  import api from '@/api'
  import SinglePane from "common-components/src/obComponents/obSinglePanels"
  import ObPagination from "common-components/src/obComponents/obPagination"
  import TreeItem from "./modal/TreeItem"
  import TnvedItem from "./modal/TnvedItem"
  import ObModal from "common-components/src/obComponents/obModal"
  import ObFuncPanel from 'common-components/src/obComponents/obFuncPanel'
  import Preloader from '@/services/Preloader/Preloader'
  import { dictionaryDefault } from '@/translations/ru/default'
  import { dictionary } from '@/translations/ru/dictionaries__cargo__tnved'

  export default {
    name: "Tnved",
    components: {
      ObModal,
      TnvedItem,
      Preloader,
      TreeItem,
      SinglePane,
      ObFuncPanel,
      ObPagination
    },
    mounted() {
      this.loadData();
    },
    computed: {
      isEmptyData() {
        return isEmpty(this.selectedCardInfo)
      }
    },
    data() {
      return {
        dictionaryRu: Object.assign(dictionary, dictionaryDefault),
        searchValue: '',
        showSearch: false,
        count: 0,
        itemOnPage: 20,
        activePage: 1,
        dataSource: [],
        selectedData: {},
        selectedCardInfo: {},
        preloader: false,
        selectedParent: {},
        indexActiveChild: null
      }
    },
    methods: {
      onToggleNavigation(nextMode) {
        let _indexActiveChild;
        if(nextMode) {
          _indexActiveChild = this.indexActiveChild < (this.selectedParent.children.length - 1) ? this.indexActiveChild + 1 : 0
        }
        else _indexActiveChild = this.indexActiveChild > 0 ? this.indexActiveChild - 1 : (this.selectedParent.children.length - 1)
        this.selectData(this.selectedParent.children[_indexActiveChild], this.selectedParent, _indexActiveChild)
      },
      search(query) {
        let from = this.activePage - 1;
        this.preloader = true;
        api.cargo.getTnvedList(from, this.itemOnPage, query).then(({data}) => {
          this.dataSource = data.content;
          this.preloader = false;
          this.count = data.total_elements
        }).catch((e) => {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        })
      },
      searchToggle() {
        this.showSearch = !this.showSearch;
        if(!this.showSearch) {
          this.searchValue = '';
          this.$emit('input', this.searchValue)
        } else {
          this.$nextTick(() => {
            this.$refs.search && this.$refs.search.focus();
          })
        }
      },
      loadData() {
        api.cargo.getTnvedCount().then(({data}) => {
          this.count = data.count;
          if (this.count) {
            this.loadPage();
          }
        }).catch((e) => {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        })
      },
      clickPage(page) {
        this.activePage = page + 1;
        this.loadPage();
      },
      loadPage() {
        let from = this.activePage - 1;
        this.preloader = true;
        api.cargo.getTnvedList(from, this.itemOnPage, this.searchValue).then(({ data }) => {
          if (!data || data.error) {
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных' })
          } else {
            this.dataSource = data.content;
            this.preloader = false;
            this.count = data.total_elements
          }
        });
      },
      async selectData(data, parent, index) {
        try {
          this.selectedParent = parent;
          this.indexActiveChild = index;
          this.selectedData = data;
          let _data = await api.cargo.getTnvedItem(data.uuid);
          this.selectedCardInfo = {...data, ..._data.data};
          this.$refs.viewItem.open();
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      }
    }
  }
</script>

<style lang="scss">
  @import "~common-components/src/static/css/mixins";
  $color-text: $color-text-base;
  $color-text-inactive: $color-grey-span;
  $color-border: $color-grey-border;
  $color-label: $color-grey-label;
  $color-grey: $color-white-lilac;
  $color-blue: $color-blue-navy-blue;
  $color-range: $light-denim ;
  $color-placeholder: $gray-window;
  $color-light-blue: $lavender;
  $color-hover: $light-lavender;
  $color-red: $color-error;
  $color-green: $color-green-light;

  $green-05: rgba($color-green-light, 0.05);

  .tree-item-title {
    border-bottom: 1px solid $color-light-blue;
    width: 100%;
    cursor: pointer;
    &.open {
      .group {
        color: $color-text;
        &::before {
          transform: rotate(0deg);
        }
      }
    }
    &:hover {
      background: $color-hover;
      .title {
        color: $color-blue;
        &.child {
          color: $color-text;
        }
      }
    }
    .title {
      @include font-mixin(14px, 21px, 400, $color-text-inactive, 0.2px);
      position: relative;
      display: inline-flex;
      flex-grow: 1;
      padding: 10px 20px;
      &.group {
        padding-left: 46px;
        &::before {
          content: '';
          background-repeat: no-repeat;
          background-position: center center;
          background-size: cover;
          width: 10px;
          height: 6px;
          transform: rotate(-90deg);
          display: block;
          position: absolute;
          top: 0;
          bottom: 0;
          left: 20px;
          margin: auto;
        }
      }
      &.child {
        padding-left: 46px;
        color: $color-text;
      }
    }
    &.open {
      .title {
        color: $color-text;
        &::before {
          transform: rotate(0deg);
        }
      }
    }
    i.icon {
      margin-right: 8px;
      margin-top: 2px;
    }
    &__code {
      margin-right: 40px;
    }
  }

  .w100 {
    width: 100%;
  }
  .tnved-page {
    justify-content: space-between;
    .tree {
      flex-grow: 2
    }
  }
  .selection {
    background-color: $color-hover;
  }

  .padding-block {
    display: inline-flex;
    width: 30px;
  }

  .pager {
    ul {
      margin: 0!important;
    }
    li {
      display: inline-block;
      a {
        @include font-mixin(12px, 12px, 400, $color-text, 0.4px);
        padding: 5px 7px!important;
        border-radius: 50%;
      }
      &.active {
        a {
          color: white;
          background: $color-blue;
        }
      }
    }
  }
  .not-data {
    color: $color-text-inactive;
    text-align: center;
    padding: 10px;
  }
  .content-footer {
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 10px 20px;
    border-top: 1px solid $color-light-blue;
    .count {
      flex-shrink: 0;
      margin-right: 30px;
    }
    .pager {
      text-align: right;
      flex-grow: 1;
    }
    .pagination {
      justify-content: center;
    }
  }
</style>

